
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string>
#include <sstream>
#include "resource.h"
#include <fstream>
#include <iostream>
#include "charStore.h"
#include "crctable.c"


//////// GLOBALS ///////////
 HMENU hMenuBar =CreateMenu();
 HMENU hFile = CreateMenu();
 HMENU hConvert = CreateMenu();
 HWND hwnd, hBuild, hUserInfo;
 HWND hNewCaptions;
 
 std::string cauismia;
 std::string org_wavPath;
 std::string getDrivePath;
 std::string holdpathway;
 std::string baseFileName;
 std::string new_caupath;
 std::string fileNameOnly;
 
 int caufolder=0;
 int tpawriteok=0;
 int abortcau=0;
 int wavfolder=0;
 char* linea_buf;
 int edline1=0;
 int tpafail=0;
 
 struct SampleHeader 
  {
    unsigned long headerid;
    unsigned long cautype;
    unsigned long CaptionLen;
    unsigned long CauBlocOne;
    unsigned long Cau_Len_WaData;
    unsigned long CIma_Wave_Data;
    unsigned long Cau_SampleRate;
    unsigned char Cau_BitRate;
    unsigned char Cau_NumChan;
    short Cau_Compres;
    unsigned long Is_Captions;
    };
                   
 void readSampleHeader(struct SampleHeader &blockC, FILE *Cau) {
      fread(&blockC, sizeof(SampleHeader), 1, Cau); 
}

void writeSampleHeader( struct SampleHeader &blockC, FILE *Tpa) {
      fwrite(&blockC, sizeof(SampleHeader), 1, Tpa);   
}
 //////////////////////    RETURN CRC VALUE /////////////////////////////
    unsigned long CRC32(std::string & i, unsigned long Crc_value) {
    int SLen;
    SLen = i.length();
    Crc_value=0xffffffff;
    
     for (int t=0; t<SLen; t++){
      Crc_value = Crc_value >> 8 ^ crc32_table[(i[t]) ^ Crc_value & 0xFF];
    }
    
   return Crc_value;
  }
  
 /////////////////// pick directory with caus ////////////////////////
 
 void choose_dir()
     {
        caufolder=0;
        OPENFILENAME ofn;
        char szCauFolder[MAX_PATH] = "";
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn); 
        ofn.hwndOwner = hwnd;
        ofn.lpstrFilter = "Cau File (*.cau)\0*.cau\0";
        ofn.lpstrFile = szCauFolder;
        ofn.nMaxFile = MAX_PATH;
        ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
        |OFN_PATHMUSTEXIST;
        ofn.lpstrDefExt = "";
                
        if(GetOpenFileName(&ofn))
         {  
           caufolder=1;
           holdpathway=szCauFolder;
           int nullname = holdpathway.rfind("\\");
           holdpathway.erase(nullname);
           holdpathway+="\\";  
	   }
     }
 
/////////////////////  choose desired tpa name ///////////////////////////  

 /////////////////// pick directory with caus ////////////////////////
 
 void choose_tpa()
     {  
        tpawriteok=0;
        OPENFILENAME ofn;
        char xzFileName[MAX_PATH] = "";
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn); 
        ofn.hwndOwner = hwnd;
        ofn.lpstrFilter = "Tpa File (*.tpa)\0*.tpa\0";
        ofn.lpstrFile = xzFileName;
        ofn.nMaxFile = MAX_PATH;
        ofn.Flags = OFN_EXPLORER |OFN_PATHMUSTEXIST;
        ofn.lpstrDefExt = "";
	
	    if(GetSaveFileName(&ofn))
         {  
           tpawriteok=1;    
           baseFileName=xzFileName;
    
           int chopper= baseFileName.rfind("\\");
           baseFileName.erase(0, chopper+1);           
           baseFileName+".tpa";
           fileNameOnly=baseFileName;  
           fileNameOnly.erase(fileNameOnly.length()-4, 4);
        }
      }
/////////////////// caus to tpa function ///////////////////////////////// 

void caus_to_tpa()
  {
  	       tpafail=0;
	       FILE *headers;
 	       FILE *samples;
 	       FILE *wborns;
 	       char *buffer;
 	       std::ifstream caufile;
 	       std::ofstream gameids;
 	       std::string cau2tpa;
 	       std::string samplepack;
 	       std::string causampname;
 	       std::string cauFullPath;
 	       int addzeros=0;
 	       std::stringstream xyz;
 	       std::string holdEntry;
 	       
		   unsigned long Cau_Len_WavData;
		   unsigned long nada = 0;  
		   unsigned long Cau_DataOffset;
		   unsigned long Header_voidVal=0;
		   unsigned long headerid;
		   
 	       int caus_size;
 	       unsigned char cachar;
 	       unsigned char zchar=0;
 	       
			cau2tpa=holdpathway;
			cau2tpa+="_header.tpa";
			

			samplepack=holdpathway;
			samplepack+=baseFileName;

 		   std::string outnames;
	       outnames=holdpathway;
 	       outnames+=fileNameOnly;
		   outnames+="_SampleIDs.txt";	  
		   
           gameids.open(outnames.c_str(), std::ios::out); 		              
           
           int cauCount=0;
           samples  = fopen(samplepack.c_str(),"wb");
           headers  = fopen(cau2tpa.c_str(),"wb");
 
           std::string chopcau;
           std::string caupaths=holdpathway;
           
           std::string exttype = "*.cau";
           std::string opnthisLoc = holdpathway + exttype;           
           

           WIN32_FIND_DATA file;
           HANDLE hFind;
           
           hFind=FindFirstFile(opnthisLoc.c_str(), &file);
           cauCount++;
 
            while (FindNextFile(hFind, &file)>0)
            {
            cauCount++;
           }
            FindClose(hFind);
            
         if(cauCount>2)
		  {   
           addzeros=cauCount; //number of caus to be added 
           addzeros=addzeros*56; //cau number * 56 (header)
           addzeros=addzeros+80; //combine 1st 44 & last 36
           
           //add all header bytes as zeros - will be overwritten
           //with header.tpa data at end of while loop -
 		    for(int q=0; q<addzeros; q++) 
		     {
		      fwrite(&zchar, sizeof(unsigned char), 1, samples);
		     }          
             
			fwrite(&rawtpa, sizeof(unsigned char), 44, headers);         
            fwrite(&rawmissing ,sizeof(unsigned char), 88236, samples); 
            
            unsigned long entrynumber;
            unsigned long tpafilesize;

             hFind=FindFirstFile(opnthisLoc.c_str(), &file);
             cauFullPath=caupaths;
             cauFullPath+=file.cFileName;
             causampname=file.cFileName;
             causampname.erase(causampname.length()-4, 4);
             
             gameids<<"INGAME SAMPLE: "<<causampname.c_str()<<std::endl;
             
          for(int w=0; w<causampname.length() ; ++w)
            {
            causampname[w] = std::tolower(causampname[w]);
           }             
             
             holdEntry=cauFullPath;
             caufile.open(cauFullPath.c_str(), std::ios::in | std::ios::binary);            
             caufile.seekg( 0, std::ios::end );
             caus_size = caufile.tellg();
             caufile.seekg( 0, std::ios::beg );            
             caufile.close();
             
             buffer=(char*)calloc(caus_size, sizeof(char));
             
		     tpafilesize=addzeros + 88236;	
			 Cau_DataOffset=tpafilesize;              
 
             wborns = fopen(cauFullPath.c_str(), "rb");
             
             fread(buffer, sizeof(char), caus_size, wborns);
             fwrite(buffer, sizeof(char), caus_size, samples);             
		    
		    free(buffer); 
			fclose(wborns);
			wborns=fopen(cauismia.c_str(),"rb");
             
            fseek(wborns, 0, SEEK_SET);
            
	  	    SampleHeader blockC;
		    readSampleHeader(blockC, wborns);
		    writeSampleHeader(blockC, headers);	            
            
			
  unsigned long ulCRC;
  std::stringstream CZ;
  char nwhash[8];
  unsigned long nCRC = CRC32(causampname, ulCRC);
  nCRC = ~nCRC;
  
  itoa(nCRC, nwhash, 16); 
  		
          fwrite(&nCRC, sizeof(unsigned long), 1, headers);
          fwrite(&Cau_DataOffset, sizeof(unsigned long), 1, headers);
    
          Cau_Len_WavData=caus_size;
    
          fwrite(&Cau_Len_WavData, sizeof(unsigned long), 1, headers);
          fwrite(&Header_voidVal, sizeof(unsigned long), 1, headers);
          fwrite(&Header_voidVal, sizeof(unsigned long), 1, headers);	
		  	    
          fclose(wborns);      
          cauFullPath.erase();
          causampname.erase();
             
          
        while (FindNextFile(hFind, &file)>0) 
         {          	
             tpafilesize+=caus_size;         	 
             cauFullPath=caupaths;
             cauFullPath+=file.cFileName;
             causampname=file.cFileName;
             causampname.erase(causampname.length()-4, 4);
             
             gameids<<"INGAME SAMPLE: "<<causampname.c_str()<<std::endl;            
             
           for(int v=0; v<causampname.length() ; ++v)
            {
            causampname[v] = std::tolower(causampname[v]);
            }               
             
             caufile.open(cauFullPath.c_str(), std::ios::in | std::ios::binary);            
             caufile.seekg( 0, std::ios::end );
             caus_size = caufile.tellg();
             caufile.seekg( 0, std::ios::beg );            
             caufile.close();
             
             buffer=(char*)calloc(caus_size, sizeof(char));
             
             Cau_DataOffset=tpafilesize;              
 
             wborns = fopen(cauFullPath.c_str(), "rb");
             
             fread(buffer, sizeof(char), caus_size, wborns);
             fwrite(buffer, sizeof(char), caus_size, samples);                            
             
            free(buffer);
            fclose(wborns);
            wborns=fopen(holdEntry.c_str(),"rb");
            fseek(wborns, 0, SEEK_SET);
            
		    readSampleHeader(blockC, wborns);
		    writeSampleHeader(blockC, headers);	         
            
			
  unsigned long ulCRC;
  std::stringstream CZ;
  char nwhash[8];
  unsigned long nCRC = CRC32(causampname, ulCRC);
  nCRC = ~nCRC;
  
  itoa(nCRC, nwhash, 16); 
  		
          fwrite(&nCRC, sizeof(unsigned long), 1, headers);
          fwrite(&Cau_DataOffset, sizeof(unsigned long), 1, headers);
    
          Cau_Len_WavData=caus_size;
    
          fwrite(&Cau_Len_WavData, sizeof(unsigned long), 1, headers);
          fwrite(&Header_voidVal, sizeof(unsigned long), 1, headers);
          fwrite(&Header_voidVal, sizeof(unsigned long), 1, headers);	
		  	
			  
		  holdEntry=cauFullPath;	       
          fclose(wborns);      
          cauFullPath.erase(); 
          causampname.erase();
           } 
///////////////// write last header 36bytes //////////////////////////
            wborns=fopen(holdEntry.c_str(),"rb");
            fseek(wborns, 0, SEEK_SET);
            
		    readSampleHeader(blockC, wborns);
		    writeSampleHeader(blockC, headers);	   
			            
			fclose(wborns);
/////////////////////////////////////////////////////////////////////        
 	           
             FindClose(hFind);
             fclose(samples);
             fclose(headers);              
            
             tpafilesize+=caus_size; //add last cau sample to tpa size
             
             unsigned long newentryno=cauCount+1;
             unsigned long newtpasize=tpafilesize;
             unsigned long missoffset=addzeros;
             unsigned wrtChar;
             
             //below, replace values with the actual sample counts and
             //filesize as well as the missing sample offset -
             headers  = fopen(cau2tpa.c_str(),"rb+"); 
			 fseek(headers, 0x04, SEEK_SET);
			 fwrite(&newentryno, sizeof(unsigned long), 1, headers);
			 fseek(headers, 0x08, SEEK_CUR);
			 fwrite(&newtpasize, sizeof(unsigned long), 1, headers);
			 fwrite(&newentryno, sizeof(unsigned long), 1, headers);
			 fseek(headers, 0x04, SEEK_CUR);
			 fwrite(&missoffset, sizeof(unsigned long), 1, headers);
			 fseek(headers, 0, SEEK_SET);
			 samples = fopen(samplepack.c_str(), "rb+");
			 fseek(samples, 0, SEEK_SET);
			 
			 //overwrite samples.tpa zeros with actual header data
			 //from temporary header.tpa file (is deleted at end)
			 for(int v=0; v<addzeros; v++) 
			  {
			  fread(&wrtChar, sizeof(unsigned char), 1, headers);
			  fwrite(&wrtChar, sizeof(unsigned char), 1, samples);	
			  }
			 
			 fclose(headers);
			 fclose(samples);
			 gameids.close();
             
             DeleteFile(cau2tpa.c_str()); //delete temp header tpa
            }
             else {
             	gameids.close();
             	fclose(headers);
             	fclose(samples);
             	tpafail=1;
             	DeleteFile(outnames.c_str());
             	DeleteFile(samplepack.c_str());
             	DeleteFile(cau2tpa.c_str());
             }
        } 
         
  ////////// function below converts wavs to caus ////////////////////
  
     void Export_Batch()
    {
         int wavType=3; //do not create a .cau unless wav compatible
         FILE *WavCheck;
         WavCheck = fopen (org_wavPath.c_str(), "rb");
         char balign, nuchan;
         unsigned long samp_rate;
         unsigned long wvformat;
         short PcmBlockSize;
         char PcmBksize, PcmBksize2;
         
         fseek(WavCheck, 0x10, SEEK_SET);
         fread(&wvformat, sizeof (unsigned long), 1, WavCheck);
         fseek(WavCheck, 2, SEEK_CUR);
         fread(&nuchan, sizeof (char), 1, WavCheck);
         fseek(WavCheck, 1, SEEK_CUR);
         fread(&samp_rate, sizeof (unsigned long), 1, WavCheck);
         fseek(WavCheck, 4, SEEK_CUR);
         fread(&PcmBlockSize, sizeof (short), 1, WavCheck);
         fclose(WavCheck);
         
         //standard pcm wav
         if(wvformat==16 ){
           wavType = 0;
           } 
         
         //ima/dvi adpcm, with compatible block alignment -
         if(wvformat==20 && PcmBlockSize==1028 || wvformat==20 &&
           PcmBlockSize==2056){
           wavType = 1; 
          }
          
         //correct wav type, incompatible block alignment -
         if(wvformat==20 && wavType==0){
          wavType = 2;
           }

         std::string wavname; 
           
        if(wavType==0 || wavType==1){ 
          unsigned long wavSample;
          unsigned char wavChannel;
             
         FILE *cauout, *wavFile;
         
         cauout = fopen(new_caupath.c_str(), "wb");
         wavFile = fopen(org_wavPath.c_str(), "rb");
         
         unsigned long wavLength;
         unsigned long imaLength;
         unsigned long pcmLength;
         unsigned long noCaption=0x24;
         unsigned long zerobytes=0x00;
         unsigned char tenval;
         unsigned char sixval=16;
         unsigned char iselvn=14;
         unsigned char oneval=1;
         unsigned char iszero=0;
         unsigned long oneChar;
         unsigned char addChar;
         unsigned char imaOne;
         unsigned char imaTwo;
         
         fseek(wavFile, 0x20, SEEK_SET);
         fread(&imaOne, sizeof(unsigned char),  1, wavFile);
         fread(&imaTwo, sizeof(unsigned char),  1, wavFile);
         
         fread(&tenval,   sizeof(unsigned char), 1, wavFile);
         
         fseek(wavFile, 0x16, SEEK_SET); //number of channels
         fread(&wavChannel, sizeof(unsigned char),1,wavFile);
         
         fseek(wavFile, 1, SEEK_CUR);  // sample rate for wav
         fread(&wavSample, sizeof(unsigned long), 1,wavFile);
         
         fseek(wavFile, 0x28, SEEK_SET); // actual wav length
         fread(&wavLength, sizeof(unsigned long), 1,wavFile);
         
         if(wavType==1){
         fseek(wavFile, 4, SEEK_CUR);
         fread(&imaLength, sizeof(unsigned long),1, wavFile);
         fseek(wavFile, 4, SEEK_CUR);
         fread(&pcmLength, sizeof(unsigned long),1, wavFile);
          }
         
         if(wavType==0){         
         // standard pcm file
         fwrite(&rawWBOR ,sizeof(unsigned char), 16, cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavSample, sizeof(unsigned long), 1,cauout);
         fwrite(&tenval,  sizeof(unsigned char),   1,cauout);
         fwrite(&wavChannel,sizeof(unsigned char), 1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&zerobytes, sizeof(unsigned long),1, cauout);
         }
          
         if(wavType==1){    
         //compressed type
         fwrite(&rawBblock, sizeof(unsigned char), 8,cauout);
         fwrite(&noCaption, sizeof(unsigned long), 1,cauout);
         fwrite(&imaOne,   sizeof(unsigned char), 1, cauout);
         fwrite(&imaTwo,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&pcmLength, sizeof(unsigned long),1, cauout);
         fwrite(&imaLength, sizeof(unsigned long),1, cauout);
         fwrite(&wavSample, sizeof(unsigned long),1, cauout);
         fwrite(&sixval,   sizeof(unsigned char), 1, cauout);
         fwrite(&wavChannel, sizeof(unsigned char),1,cauout);
         fwrite(&oneval, sizeof(unsigned char),  1,  cauout);
         fwrite(&iszero, sizeof(unsigned char),  1,  cauout);
         fwrite(&zerobytes, sizeof(unsigned long), 1,cauout);
         
         wavLength=0;
         wavLength=pcmLength;
        }
          
         int longCount=0;
         
         for(int z=0; z<wavLength/4; z++){ // write by fours
         longCount+=4;
         fread(&oneChar, sizeof(unsigned long), 1, wavFile);
         fwrite(&oneChar,sizeof(unsigned long), 1,  cauout);
          }
         
         while (longCount<wavLength){ // write out any stray
          ++longCount;
         fread(&addChar, sizeof(unsigned char), 1, wavFile);
         fwrite(&addChar, sizeof(unsigned char), 1, cauout);
         }
         
         fclose(cauout);
         fclose(wavFile);
        } 		
          } // closes function
           
/////////////////////////////////////////////////////////////////




   void Export_Cau()
    {
        int imaType=3; //do not create .cau unless compatible wav selected -
         abortcau=0;        
        OPENFILENAME ofn;
        char wvFileName[MAX_PATH] = "";
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn); 
        ofn.hwndOwner = hwnd;
        ofn.lpstrFilter = "Wav File (*.wav)\0*.wav\0";
        ofn.lpstrFile = wvFileName;
        ofn.nMaxFile = MAX_PATH;
        ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY
        |OFN_PATHMUSTEXIST;
        ofn.lpstrDefExt = "";
    
        if(GetOpenFileName(&ofn))
         {
         abortcau=1;	
         FILE *WavCheck;
         WavCheck = fopen (wvFileName, "rb");
   
         char balign, nuchan;
         unsigned long samp_rate;
         unsigned long wvformat;
         short PcmBlockSize;
         char PcmBksize, PcmBksize2;
         
         fseek(WavCheck, 0x10, SEEK_SET);
         fread(&wvformat, sizeof (unsigned long), 1, WavCheck);
         fseek(WavCheck, 2, SEEK_CUR);
         fread(&nuchan, sizeof (char), 1, WavCheck);
         fseek(WavCheck, 1, SEEK_CUR);
         fread(&samp_rate, sizeof (unsigned long), 1, WavCheck);
         fseek(WavCheck, 4, SEEK_CUR);
         fread(&PcmBlockSize, sizeof (short), 1, WavCheck);
         fclose(WavCheck);
         
         //standard pcm wav
         if(wvformat==16 ){
           imaType = 0;
           }
         
         //ima/dvi adpcm, with compatible block alignment -
         if(wvformat==20 && PcmBlockSize==1028 || wvformat==20 &&
           PcmBlockSize==2056){
           imaType = 1; 
          }
          
         //correct wav type, incorrect block alignment -
         if(wvformat==20 && imaType==0){
          imaType = 2;
          abortcau=0;
           }     
           
        if(imaType==0 || imaType==1){ 
          unsigned long wavSample;
          unsigned char wavChannel;
          std::string curdirect;
          std::string capdata;
          std::string massexportEx;
          std::string wavname;
          
          wavname=wvFileName;   //open .wav
          curdirect=wvFileName; //hold .cau

          int stripit = massexportEx.rfind("\\");
          massexportEx.erase(stripit+1);
          
          int extname = wavname.rfind("\\");
          wavname.erase(0, extname+1);
          int lstrip = wavname.find(".");
          wavname.erase(lstrip,4);
          
          curdirect=massexportEx;
          curdirect+=wavname;
          curdirect+=".cau";
          
          capdata=massexportEx;
          capdata+="captions.log";

              //char* linea_buf;

              unsigned long TLenCount;
              unsigned long LineCount;
              
              FILE *capFile;

              BOOL bExitFired=FALSE;
              BOOL bShowMsgBox=FALSE;
  
           // int edline1 = GetWindowTextLength(GetDlgItem(hwnd,IDE_CAPONE));
            
            if(edline1 > 0) 
              {
              //  linea_buf = (char*)GlobalAlloc(GPTR, edline1 + 1);
               // GetDlgItemText(hwnd, IDE_CAPONE, linea_buf, edline1 + 1);
               //MessageBox(NULL, "we are inside", NULL,MB_OK);
               
                TLenCount=edline1+53; // may omit the extra data at end (5)
                LineCount=1;
              
                std::ofstream capsout(capdata.c_str(), std::ios::out | std::ios::binary);
                capsout<<linea_buf;
                capsout.close();
                
               char numReturns;
                
                std::fstream numType(capdata.c_str(), std::ios::in | std::ios::binary);
                numType.seekg(0, std::ios::beg);
         
            while (numType.read(&numReturns, 1)){
                 if(numReturns==13){
                  LineCount+=1;
                  TLenCount+=3;
                  }
                 }
                numType.close();
              }  
               
// *****************************************************************************     
         FILE *cauout, *wavFile;
         
         cauout = fopen(curdirect.c_str(), "wb");
         
         wavFile = fopen(wvFileName, "rb");
         
         unsigned long wavLength;
         unsigned long imaLength;
         unsigned long pcmLength;
         unsigned long noCaption=0x24;
         unsigned long fourzeros=0x00;
         unsigned char tenval;
         unsigned char sixval=16;
         unsigned char iselvn=14;
         unsigned char oneval=1;
         unsigned char iszero=0;
         unsigned long oneChar;
         unsigned char addChar;
         unsigned char imaOne;
         unsigned char imaTwo;
         
         fseek(wavFile, 0x20, SEEK_SET);
         fread(&imaOne, sizeof(unsigned char),  1, wavFile);
         fread(&imaTwo, sizeof(unsigned char),  1, wavFile);
         
         fread(&tenval,   sizeof(unsigned char), 1, wavFile);
         
         fseek(wavFile, 0x16, SEEK_SET); //number of channels
         fread(&wavChannel, sizeof(unsigned char),1,wavFile);
         
         fseek(wavFile, 1, SEEK_CUR);  // sample rate for wav
         fread(&wavSample, sizeof(unsigned long), 1,wavFile);
         
         fseek(wavFile, 0x28, SEEK_SET); // actual wav length
         fread(&wavLength, sizeof(unsigned long), 1,wavFile);
         
         if(imaType==1){
         fseek(wavFile, 4, SEEK_CUR);
         fread(&imaLength, sizeof(unsigned long),1, wavFile);
         fseek(wavFile, 4, SEEK_CUR);
         fread(&pcmLength, sizeof(unsigned long),1, wavFile);
          }
         
         if(imaType==0){
         
         if(edline1 > 0){
         fwrite(&rawBblock, sizeof(unsigned char), 8, cauout);
         fwrite(&TLenCount, sizeof(unsigned long), 1, cauout);
         fwrite(&fourzeros, sizeof(unsigned long), 1, cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1, cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1, cauout);
         fwrite(&wavSample, sizeof(unsigned long), 1, cauout);
         fwrite(&tenval,  sizeof(unsigned char),   1, cauout);
         fwrite(&wavChannel,sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1, cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1, cauout);
         
         unsigned long posCaptions=36;
         fwrite(&posCaptions,sizeof(unsigned long),1, cauout);
         
         unsigned long sentenceLen=TLenCount-40;
         fwrite(&sentenceLen,sizeof(unsigned long),1,cauout);
         
         fwrite(&LineCount, sizeof(unsigned long), 1,cauout);
         
         unsigned long MiliSecs=10;
         fwrite(&MiliSecs, sizeof(unsigned long), 1, cauout);
         
         unsigned char testchar;
         
         capFile = fopen(capdata.c_str(), "rb");
         
          for (int c=0; c<edline1; c++){
         fread(&testchar, sizeof(char), 1, capFile);
         
         if(testchar=='\n'){
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iselvn,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
          }
         
         if(testchar==10 || testchar==13 || testchar==0){
         //do nothing, really. ..
         testchar=0;
         }
         else{
         fwrite(&testchar, sizeof(char), 1, cauout);
         }
          }
         fclose(capFile);
 
         fwrite(&fourzeros, sizeof(unsigned long),1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         
         DeleteFile(capdata.c_str());
          }
         
         if(edline1==0){ // if no caption data, the easy out
         fwrite(&rawWBOR ,sizeof(unsigned char), 16, cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavSample, sizeof(unsigned long), 1,cauout);
         fwrite(&tenval,  sizeof(unsigned char),   1,cauout);
         fwrite(&wavChannel,sizeof(unsigned char), 1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&fourzeros, sizeof(unsigned long),1, cauout);
          }
         }
          
         if(imaType==1){
         
         if(edline1 > 0){
         fwrite(&rawBblock, sizeof(unsigned char), 8, cauout);
         fwrite(&TLenCount, sizeof(unsigned long), 1, cauout);
         fwrite(&imaOne,   sizeof(unsigned char), 1, cauout);
         fwrite(&imaTwo,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&pcmLength, sizeof(unsigned long),1, cauout);
         fwrite(&imaLength, sizeof(unsigned long),1, cauout);
         fwrite(&wavSample, sizeof(unsigned long),1, cauout);
         fwrite(&sixval,   sizeof(unsigned char), 1, cauout);
         fwrite(&wavChannel, sizeof(unsigned char),1,cauout);
         fwrite(&oneval, sizeof(unsigned char),  1,  cauout);
         fwrite(&iszero, sizeof(unsigned char),  1,  cauout);
         
         unsigned long imaCaptions=36;
         fwrite(&imaCaptions,sizeof(unsigned long),1, cauout);
         
         unsigned long sentenceIma=TLenCount-40;
         fwrite(&sentenceIma,sizeof(unsigned long),1,cauout);
         
         fwrite(&LineCount, sizeof(unsigned long), 1,cauout);
         
         unsigned long MiliImas=10;
         fwrite(&MiliImas, sizeof(unsigned long), 1, cauout);
         
         unsigned char imaschar;
         
         capFile = fopen(capdata.c_str(), "rb");
         
          for (int f=0; f<edline1; f++){
         fread(&imaschar, sizeof(char), 1, capFile);
         
         if(imaschar=='\n'){
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iselvn,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
          }
         
         if(imaschar==10 || imaschar==13 || imaschar==0){
         //do nothing, really. ..
         imaschar=0;
         }
         else{
         fwrite(&imaschar, sizeof(char), 1, cauout);
         }
          }
          
         fclose(capFile);
         DeleteFile(capdata.c_str());
       
         fwrite(&fourzeros, sizeof(unsigned long),1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         
         wavLength=0;
         wavLength=pcmLength;
          }
         
         if(edline1==0){ //ima & no caption data - easy write
         fwrite(&rawBblock, sizeof(unsigned char), 8,cauout);
         fwrite(&noCaption, sizeof(unsigned long), 1,cauout);
         fwrite(&imaOne,   sizeof(unsigned char), 1, cauout);
         fwrite(&imaTwo,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&pcmLength, sizeof(unsigned long),1, cauout);
         fwrite(&imaLength, sizeof(unsigned long),1, cauout);
         fwrite(&wavSample, sizeof(unsigned long),1, cauout);
         fwrite(&sixval,   sizeof(unsigned char), 1, cauout);
         fwrite(&wavChannel, sizeof(unsigned char),1,cauout);
         fwrite(&oneval, sizeof(unsigned char),  1,  cauout);
         fwrite(&iszero, sizeof(unsigned char),  1,  cauout);
         fwrite(&fourzeros, sizeof(unsigned long), 1,cauout);
         
         wavLength=0;
         wavLength=pcmLength;
         }
          }
          
         int longCount=0;
         
         for(int z=0; z<wavLength/4; z++){ // write out dat
         ++longCount;
         fread(&oneChar, sizeof(unsigned long), 1, wavFile);
         fwrite(&oneChar,sizeof(unsigned long), 1,  cauout);
          }
         
         longCount=longCount*4;
         
         while (longCount<wavLength){ // write out any stray
          ++longCount;
         fread(&addChar, sizeof(unsigned char), 1, wavFile);
         fwrite(&addChar, sizeof(unsigned char), 1, cauout);
         }
         
         if(linea_buf>0){
         GlobalFree((HANDLE)linea_buf);
         }
         
         fclose(cauout);
         fclose(wavFile);
        } 
         }   // closes inside &ofn Loop
         
         if(imaType==2){
          MessageBox(NULL, "Incorrect block alignment (no .cau file"
          " exported).  Selected .wav incompatible with Trespasser.",
          "Tpa_Generator - Error",MB_OK);
           }
         if(imaType==3 && abortcau==1){
          MessageBox(NULL, "Incorrect adpcm .wav type (no .cau file"
          " exported).  Selected .wav incompatible with Trespasser.",
          "Tpa_Generator - Error",MB_OK);
           }    
    }
